/****************************************************************************
** Form interface generated from reading ui file 'microsim.ui'
**
** Created: 2019-11-06T03:39:42
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef MICROSIM_H
#define MICROSIM_H

#include <qvariant.h>
#include <qmainwindow.h>
#include <vector>
#include "qfile.h"
#include "qbuttongroup.h"
#include "aboutdialog.h"
#include "helpbrowser.h"
#include "processor.h"
#include "symbol.h"
#include "instruction.h"
#include "interface.h"
#include "thread.h"
#include "pindialog.h"
#include "qtimer.h"
#include "watchregister.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class QTabWidget;
class QWidget;
class QGroupBox;
class QPushButton;
class QListView;
class QListViewItem;
class QRadioButton;
class QLabel;
class QCheckBox;
class QLineEdit;
class QTable;
class QComboBox;

class MicroSim : public QMainWindow
{
    Q_OBJECT

public:
    MicroSim( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
    ~MicroSim();

    QTabWidget* mainTabWidget;
    QWidget* tab;
    QGroupBox* gbSourceView;
    QTabWidget* srcTabWidget;
    QWidget* tab_2;
    QGroupBox* gbHistoryList;
    QPushButton* clearHistoryList;
    QListView* historyListView;
    QWidget* tab_3;
    QGroupBox* gbWatchView;
    QListView* watchView;
    QGroupBox* gbOpcodeView;
    QListView* opListView;
    QGroupBox* PCLabel;
    QRadioButton* radioButtonEEPROM;
    QLabel* textLabel1_3;
    QLabel* statusLabel;
    QLabel* WLabel;
    QCheckBox* viewNames;
    QLabel* regEditLabel;
    QLineEdit* leRegEdit;
    QLineEdit* lePC;
    QLineEdit* leWReg;
    QLineEdit* leStatus;
    QRadioButton* radioButtonProg;
    QRadioButton* radioButtonRAM;
    QTable* regViewTable;
    QWidget* TabPage;
    QGroupBox* gbMapper;
    QLabel* chipLabel3;
    QLabel* chipLabel6;
    QLabel* chipLabel5;
    QLabel* chipLabel2;
    QLabel* chipLabel1;
    QPushButton* pushButton3;
    QGroupBox* pinBox1;
    QLabel* pinLabel8;
    QLabel* pinLabel7;
    QLabel* pinLabel4;
    QLabel* pinLabel3;
    QLabel* pinLabel2;
    QLabel* pinLabel1;
    QLabel* pinLabel9;
    QLabel* pinLabel6;
    QGroupBox* stateBox1;
    QLabel* stateLabel2;
    QLabel* stateLabel3;
    QLabel* stateLabel6;
    QLabel* stateLabel7;
    QLabel* stateLabel8;
    QLabel* stateLabel9;
    QLabel* stateLabel1;
    QLabel* stateLabel4;
    QGroupBox* stateBox2;
    QLabel* stateLabel10;
    QLabel* stateLabel11;
    QLabel* stateLabel12;
    QLabel* stateLabel13;
    QLabel* stateLabel17;
    QLabel* stateLabel18;
    QLabel* stateLabel16;
    QLabel* stateLabel15;
    QGroupBox* dirBox1;
    QLabel* dirLabel2;
    QLabel* dirLabel3;
    QLabel* dirLabel4;
    QLabel* dirLabel6;
    QLabel* dirLabel7;
    QLabel* dirLabel8;
    QLabel* dirLabel9;
    QLabel* dirLabel1;
    QLabel* chipLabel8;
    QLabel* chipLabel7;
    QLabel* chipLabel16;
    QLabel* chipLabel15;
    QLabel* chipLabel14;
    QLabel* chipLabel13;
    QLabel* chipLabel12;
    QLabel* chipLabel11;
    QLabel* chipLabel9;
    QLabel* chipLabel10;
    QGroupBox* pinBox2;
    QLabel* pinLabel10;
    QLabel* pinLabel11;
    QLabel* pinLabel12;
    QLabel* pinLabel13;
    QLabel* pinLabel15;
    QLabel* pinLabel16;
    QLabel* pinLabel17;
    QLabel* pinLabel18;
    QGroupBox* assignBox;
    QLabel* comboLabel1;
    QLabel* comboLabel2;
    QLabel* comboLabel13;
    QLabel* comboLabel17;
    QLabel* comboLabel18;
    QComboBox* comboBox13;
    QComboBox* comboBox12;
    QLabel* comboLabel12;
    QComboBox* comboBox11;
    QLabel* comboLabel11;
    QComboBox* comboBox10;
    QLabel* comboLabel10;
    QComboBox* comboBox9;
    QComboBox* comboBox8;
    QComboBox* comboBox7;
    QComboBox* comboBox6;
    QLabel* comboLabel3;
    QLabel* comboLabel6;
    QComboBox* comboBox3;
    QComboBox* comboBox18;
    QComboBox* comboBox17;
    QComboBox* comboBox2;
    QComboBox* comboBox1;
    QLabel* comboLabel9;
    QLabel* comboLabel7;
    QLabel* comboLabel8;
    QGroupBox* groupBox20;
    QRadioButton* rbParallelPort1;
    QRadioButton* rbParallelPort2;
    QRadioButton* rbParallelPort3;
    QPushButton* saveMapButton;
    QPushButton* loadMapButton;
    QGroupBox* stateBox3;
    QLabel* dirLabel10;
    QLabel* dirLabel11;
    QLabel* dirLabel12;
    QLabel* dirLabel13;
    QLabel* dirLabel17;
    QLabel* dirLabel18;
    QLabel* dirLabel16;
    QLabel* dirLabel15;
    QGroupBox* groupBox21;
    QComboBox* freqCombo;
    QLabel* bigChipPic;
    QWidget* TabPage_2;
    QGroupBox* gbSourceView_2;
    QTabWidget* srcTabWidget_2;
    QWidget* tab_4;
    QGroupBox* gbhistoryList_2;
    QListView* historyListView_2;
    QGroupBox* gbMapper2;
    QLabel* chipLabel1_2;
    QLabel* chipLabel2_2;
    QLabel* chipLabel3_2;
    QLabel* chipLabel4_2;
    QLabel* chipLabel5_2;
    QLabel* chipLabel6_2;
    QLabel* chipLabel7_2;
    QLabel* chipLabel8_2;
    QLabel* chipLabel11_2;
    QLabel* chipLabel12_2;
    QLabel* chipLabel13_2;
    QLabel* chipLabel14_2;
    QLabel* chipLabel15_2;
    QLabel* chipLabel16_2;
    QLabel* chipLabel10_2;
    QLabel* chipLabel9_2;
    QLabel* pinLabel10_2;
    QLabel* pinLabel11_2;
    QLabel* pinLabel13_2;
    QLabel* pinLabel12_2;
    QLabel* pinLabel9_2;
    QLabel* pinLabel8_2;
    QLabel* pinLabel7_2;
    QLabel* pinLabel6_2;
    QLabel* pinLabel4_2;
    QLabel* pinLabel3_2;
    QLabel* pinLabel2_2;
    QLabel* pinLabel1_2;
    QLabel* pinLabel18_2;
    QLabel* pinLabel15_2;
    QLabel* pinLabel116_2;
    QLabel* pinLabel17_2;
    QLabel* smallChipPic;
    QGroupBox* gbOpcodeView_2;
    QListView* opListView_2;
    QGroupBox* gbRegView_2;
    QRadioButton* radioButtonEEPROM_2;
    QRadioButton* radioButtonRAM_2;
    QRadioButton* radioButtonProg_2;
    QLineEdit* leRegEdit_2;
    QLineEdit* leStatus_2;
    QLineEdit* lePC_2;
    QLineEdit* leWReg_2;
    QLabel* statusLabel_2;
    QLabel* WLabel_2;
    QLabel* PCLabel_2;
    QLabel* regEditLabel_2;
    QCheckBox* viewNames_2;
    QTable* regViewTable_2;
    QGroupBox* gbWatchView2;
    QListView* watchView_2;
    QMenuBar *MenuBar;
    QPopupMenu *fileMenu;
    QPopupMenu *Program;
    QPopupMenu *Breakpoints;
    QPopupMenu *helpMenu;
    QToolBar *toolBar;
    QAction* fileOpenAction;
    QAction* fileExitAction;
    QAction* helpContentsAction;
    QAction* helpAboutAction;
    QAction* menuNextAction;
    QAction* menuOverAction;
    QAction* menuRunAction;
    QAction* menuStopAction;
    QAction* breakpointsClear_AllAction;
    QAction* breakpointsClear_All_RegisterAction;

    QButtonGroup* radioGroup3;
    vector<WatchRegister> watchRegisters;
    QComboBox* comboArray[19];
    PinDialog* pinDialog;
    bool file_is_loaded;
    Interface* interface;
    Processor* cpu;
    QButtonGroup* radioGroup1;
    QButtonGroup* radioGroup2;
    AboutDialog* aboutDialog;
    HelpBrowser* helpBrowser;
    QListView** srcPages;
    QString openFile;
    bool showOpen;
    QTimer* timer;
    QListView** srcPages_2;
    QTimer* runTimer;
    char* instructionBuffer[30];
    int instBuffCount;
    int instructionRate;

    virtual QString formatPP( int PICpin );
    virtual QString getPinDir( int PICpin );
    virtual QString getPinState( int port, int bit );

public slots:
    virtual void fileOpen();
    virtual void removeSourcePages();
    virtual void NewSource();
    virtual void srcPageListClick( QListViewItem * item, const QPoint & point, int n );
    virtual void loadSourceFile( FILE * fp, int i );
    virtual void loadHeaderFile( FILE * fp, int i );
    virtual void saveMappingFile();
    virtual void loadMappingFile();
    virtual void fileExit();
    virtual void helpContents();
    virtual void helpAbout();
    virtual void setupAllTab();
    virtual void loadW_Status_PC();
    virtual void regSelected();
    virtual void regEdited();
    virtual void regSelected_2();
    virtual void regEdited_2();
    virtual void setupHistoryList( QListView * listView );
    virtual void addToHistoryList( QListView * listView, const char * instruction );
    virtual void updateHistoryLists();
    virtual void clearHistoryLists();
    virtual void setupOpcodeList( QListView * listView );
    virtual void loadOpcodeList( QListView * listView );
    virtual void setupWatchView( QListView * listView );
    virtual void PCEdited();
    virtual void PCEdited_2();
    virtual void WEdited();
    virtual void WEdited_2();
    virtual void StatusEdited();
    virtual void StatusEdited_2();
    virtual void setupRegView( QTable * table );
    virtual void viewRegValues();
    virtual void viewRegValues_2();
    virtual void viewEEPROMValues();
    virtual void viewEEPROMValues_2();
    virtual void viewProgramMemory();
    virtual void viewProgramMemory_2();
    virtual void updateRegView( int mode );
    virtual void viewRegNames( bool flag );
    virtual void viewRegNames_2( bool flag );
    virtual void setupRegColors();
    virtual void updateSrcPages( bool flag );
    virtual void programStep();
    virtual void programRun();
    virtual void cacheInstruction( char * name );
    virtual void startProcessor();
    virtual void programHalt();
    virtual void programAlert();
    virtual void updateRegisterViewers();
    virtual void disableActions( bool flag );
    virtual void programStop();
    virtual void updatePinLabels();
    virtual void changeCombo1();
    virtual void changeCombo2();
    virtual void changeCombo3();
    virtual void changeCombo6();
    virtual void changeCombo7();
    virtual void changeCombo8();
    virtual void changeCombo9();
    virtual void changeCombo10();
    virtual void changeCombo11();
    virtual void changeCombo12();
    virtual void changeCombo13();
    virtual void changeCombo17();
    virtual void changeCombo18();
    virtual void printPins();
    virtual void initAddToWatch();
    virtual void initAddToWatch_2();
    virtual void addToWatch( int row, int col );
    virtual void removeWatchReg( QListViewItem * item, const QPoint & p, int col );
    virtual void updateWatchViewer( QListView * listView );
    virtual void watchRegister( int row, int col, int button, const QPoint & mousePos );
    virtual void watchRegister_2( int row, int col, int button, const QPoint & mousePos );
    virtual void initReadBreak();
    virtual void initReadBreak_2();
    virtual void toggleReadBreak( QTable * table, int row, int col, bool flag );
    virtual void initWriteBreak();
    virtual void initWriteBreak_2();
    virtual void toggleWriteBreak( QTable * table, int row, int col, bool flag );
    virtual void clearBPFromRegViews();
    virtual void clearBPFromSource();
    virtual void clearAllRegBP();
    virtual void clearAllBP();
    virtual void setOpFreq( int index );
    virtual void updateParallelPortAddress( int id );

protected:

protected slots:
    virtual void languageChange();

private:
    void init();
    void destroy();

};

#endif // MICROSIM_H
