/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/

void PinDialog::init()
{
    group = new QButtonGroup();
    group->insert(mode1,1);
    group->insert(mode2,2);
    group->insert(mode3,0);
    mode3->setChecked(true);
    //connect(ok,SIGNAL(clicked()),this,SLOT());
}

void PinDialog::setCPU(Processor* pic)
{
    cpu = pic;
}



void PinDialog::set_io_config()
{
    const int selected = group->selectedId();
    
    cpu->hm->setIOMode(selected);
   
    if(selected == 0)
    {
        //parent->gbMapper->setTitle("Mapper (No Assignments)"); 
        cpu->usingIO = false; 
    }
    else if(selected == 1)
    {
       // parent->gbMapper->setTitle("Mapper (0-13 Inputs / 0-4 Outputs)"); 
        cpu->usingIO = true;
    }
    else if(selected == 2)
    {
        //parent->gbMapper->setTitle("Mapper (0-5 Inputs / 0-12 Outputs)");
        cpu->usingIO = true;   
    }
    done(selected);
}
